/*
 * The declination of the sun is the angle between the equator and a line 
 * drawn from the centre of the Earth to the centre of the sun. 
 * The daily variation of the declination angle 
 * is compute in the program below.
 * 
 * graphic:
 * the moving sun level is drawn yellow
 * the trace of sun is green
 * and the equator is in white
 * 
 * this can compile w/o changes
 * i.e. for PC gcc -o sun_decl sun_decl.c -lm
 * in this case the declination is print to stdout
 * and can processed further i.e. with gnulot
 * 
 * or/and for the P2
 * fastspin -2b sun_decl.c graphictools.c
 * 
 * it is also an example to design for PC and P2 in C
 * 
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#ifdef __FLEXC__
#include <propeller.h>
#include <unistd.h>
#include <string.h>
#define P2_TARGET_MHZ 160
#include "sys/p2es_clock.h"
#include "graphictools.h"
#define BAUD 230400
#define GAIN 5
#define R	4
#endif



void main()
{
    unsigned int day;
    float declination;

#ifdef __FLEXC__   
    clkset(_SETFREQ, _CLOCKFREQ);
     Setup_Video();
    _setbaud(BAUD);
#endif    

#ifdef __FLEXC__
	while(1)
	{
	    clearscreen(BLACK);	
#endif
    for (day = 1; day < 366; day++)
    {
        declination = 23.45 * sin( 6.28 * (284+day) / 365 );
        #ifndef __FLEXC__
        printf("%d  %f\n",day,declination);
        #endif
        #ifdef __FLEXC__
        // draw sun
        fillCircle(&frameBuffer, SCRN_WIDTH*8/8, 
					10+day, 240 - GAIN*(int)declination, 
					R, ORANGE, 8);
		vid.waitforblanking(&display1);
        fillCircle(&frameBuffer, SCRN_WIDTH*8/8, 
					10+day, 240 - GAIN*(int)declination, 
					R, BLACK, 8);
		// draw the equator
		line(0,240,365,240,WHITE);
		// draw trace of sun	
        fillCircle(&frameBuffer, SCRN_WIDTH*8/8, 
					7+day, 240 - GAIN*(int)declination, 
					1, GREEN, 8);		
		} // end while(1)	
        #endif
    }
}

/*
+--------------------------------------------------------------------
| TERMS OF USE: MIT License
+--------------------------------------------------------------------
Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files
(the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+--------------------------------------------------------------------
*/
